###
* omg-diskspace
*
* Copyright (c) 2015 Ferrari electronic AG
###

"use strict"
df = require 'node-df'
debug = require("../../../shared_modules/logger").debug
filesize = require 'file-size'
_ = require 'lodash'

Producer = require "../../ProducerClass"

class Diskspace extends Producer
  isRunning = false
  constructor: ->
    super "diskspace", 10 * 1000

    getDiskSpace = false
    run = =>
      @debug "running"
      df (err, drives) =>
        _.each drives, (drive) ->
          drive.sizeHuman = filesize(drive.size * 1024).human("jedec")
          drive.usedHuman = filesize(drive.used * 1024).human("jedec")
          drive.availableHuman = filesize(drive.available * 1024).human("jedec")

        drives = (driveLoop for key, driveLoop of drives)

        @sendData drives


    #run once on startup
    run()

    @start = =>
      @debug "starting"
      #run directly
      run()
      clearInterval getDiskSpace if getDiskSpace
      getDiskSpace = setInterval run, 20 * 1000

    @stop = =>
      clearInterval getDiskSpace if getDiskSpace
      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new Diskspace()
