DumpNumber = require "./dumpNumber"
DumpCause = require "./dumpCause"

dec2hex = (i) ->
	return  ("0"+(Number(i).toString(16))).slice(-2).toUpperCase()


dumpMsg = (ba, idx) ->
	ret = ""
	if idx > ba.Length
		error = 1
		return ret
	i = 0
	while i < ba[idx]
		baIdx = i + idx + 1
		if baIdx >= ba.Length
			error = 1
			break
		ret += dec2hex ba[baIdx]

		# ret += String.Format("{0,2:X2}", ba[baIdx])
		i++
	ret

module.exports = (ba, idx) ->
	# get element length
	if ba.Length > idx + 1
		len = ba[idx + 1] + 2
	else
		len = 0

	len = 5
	switch ba[idx]
		when 0x00 then return "Segemented message:";
		when 0x04
			if len >= 5
				ret = "Bearer capability: ";
				# switch (ba[idx + 2] & 0x1f)
				switch (0)
					when 0 then ret += "Speech"; break;
					when 8 then ret += "Unrestricted Digital Information"; break;
					when 9 then ret += "Restricted Digital Information"; break;
					when 16 then ret += "3.1 kHz Audio"; break;
					when 24 then ret += "Video"; break;
				return ret;
			else
				return "Bearer capability:" + dumpMsg(ba, idx + 1);
		when 0x08 then return "Cause:" + DumpCause(ba, idx + 1);
		when 0x10 then return "Call identity:" + dumpMsg(ba, idx + 1);
		when 0x14 then return "Call state:" + dumpMsg(ba, idx + 1);
		when 0x18
			if (len is 3 && (ba[idx+2] & 0x20) is 0) # BRI
				ret = "Channel Identification: ";
				switch (ba[idx + 2] & 0x03)
					when 0x00 then ret += "No Channel"; break;
					when 0x01 then ret += "B1"; break;
					when 0x02 then ret += "B2"; break;
					when 0x03 then ret += "Any Channel"; break;
				return ret;
			else if (len >= 5 && (ba[idx+2] & 0x20) is 0x20) # PRI
				if (ba[idx + 3] is 0x83)
					return "Channel Identification: #" + ((ba[idx + 4] & 0x3f).toString());
			return "Channel identification:" + dumpMsg(ba, idx + 1);

		when 0x1c then return "Facility:" + dumpMsg(ba, idx + 1);
		when 0x1e
			if (len is 4)
				ret = "Progress indicator: ";
				switch (ba[idx + 3] & 0x7f)
					when 0x01 then ret += "Not end-to-end ISDN, further info may be available in-band"; break;
					when 0x02 then ret += "Destination address is non-ISDN"; break;
					when 0x03 then ret += "Origination address is non-ISDN"; break;
					when 0x04 then ret += "Call has returned to the ISDN"; break;
					when 0x05 then ret += "Interworking has occured"; break;
					when 0x08 then ret += "In-band information or an appropriate pattern is now available"; break;
				return ret;
			return "Progress indicator:" + dumpMsg(ba, idx + 1);
		when 0x20 then return "Network-specific facilities:" + dumpMsg(ba, idx + 1);
		when 0x27 then return "Notification indicator:" + dumpMsg(ba, idx + 1);
		when 0x28 then return "Display:" + dumpMsg(ba, idx + 1);
		when 0x29
			if (len is 8)
				return string.Format("Date/time: {0:D2}-{1:D2}-{2:D2} {3:D2}:{4:D2}:{5:D2}", ba[idx + 2], ba[idx + 3], ba[idx + 4], ba[idx + 5], ba[idx + 6], ba[idx + 7]);
			else if (len is 7)
				return string.Format("Date/time: {0:D2}-{1:D2}-{2:D2} {3:D2}:{4:D2}", ba[idx + 2], ba[idx + 3], ba[idx + 4], ba[idx + 5], ba[idx + 6]);
			else
				return "Date/time:" + dumpMsg(ba, idx + 1);
		when 0x2c then return "Keypad facility:" + dumpMsg(ba, idx + 1);
		when 0x32 then return "Information Request:" + dumpMsg(ba, idx + 1);
		when 0x34 then return "Signal:" + dumpMsg(ba, idx + 1);
		when 0x36 then return "Switchhook:" + dumpMsg(ba, idx + 1);
		when 0x38 then return "Feature Activation:" + dumpMsg(ba, idx + 1);
		when 0x39 then return "Feature Indication:" + dumpMsg(ba, idx + 1);
		when 0x40 then return "Information rate:" + dumpMsg(ba, idx + 1);
		when 0x42 then return "End-to-end transit delay:" + dumpMsg(ba, idx + 1);
		when 0x43 then return "Transit delay selection and indication:" + dumpMsg(ba, idx + 1);
		when 0x44 then return "Packet layer binary parameters:" + dumpMsg(ba, idx + 1);
		when 0x45 then return "Packet layer window size:" + dumpMsg(ba, idx + 1);
		when 0x46 then return "Packet size:" + dumpMsg(ba, idx + 1);
		when 0x47 then return "Closed user group:" + dumpMsg(ba, idx + 1);
		when 0x4a then return "Reverse charge indication:" + dumpMsg(ba, idx + 1);
		when 0x4c then return "Connected Number:" + DumpNumber(ba, idx + 1);
		when 0x6c then return "Calling party number:" + DumpNumber(ba, idx + 1);
		when 0x6d then return "Calling party subaddress:" + dumpMsg(ba, idx + 1);
		when 0x70 then return "Called party number:" + DumpNumber(ba, idx + 1);
		when 0x71 then return "Called party subaddress:" + dumpMsg(ba, idx + 1);
		when 0x74 then return "Redirecting number:" + DumpNumber(ba, idx + 1);
		when 0x76 then return "Redirection Number:" + dumpMsg(ba, idx + 1);
		when 0x78 then return "Transit network selection:" + dumpMsg(ba, idx + 1);
		when 0x79 then return "Restart indicator:" + dumpMsg(ba, idx + 1);
		when 0x7c then return "Low layer compatibility:" + dumpMsg(ba, idx + 1);
		when 0x7d
			if (len >= 4)
				ret = "High layer compatibility: ";
				switch (ba[idx + 3] & 0x7f)
					when 0x01 then ret += "Telephony"; break;
					when 0x04 then ret += "Fax Group 2/3"; break;
					when 0x21 then ret += "Fax Group 4 Class I"; break;
					when 0x24 then ret += "Fax Group 4 Class II and III"; break;
					else ret += "Something very exotic..."; break;
				return ret;
			return "High layer compatibility:" + dumpMsg(ba, idx + 1);
		when 0x7e then return "User-user:" + dumpMsg(ba, idx + 1);
		when 0x7f then return "Escape for extension:" + dumpMsg(ba, idx + 1);
		else return "Unknown Multi Byte Information Element!";
