const path = require('path')

const cwd = process.cwd()

module.exports = function () {
  Error.stackTraceLimit = Infinity
  const stack = new Error().stack
  const lines = stack.split('\n')

  let initiator = 'unknown location ()'

  let callerNumber = 0
  // console.log(lines)
  for (const line of lines) {
    const matches = line.match(/^\s+at\s+(.*)/)
    if (matches) {
      if (callerNumber > 11) { // first line - current function
        // second line - caller (what we are looking for)
        initiator = matches[1]
        break
      }
      callerNumber++
    }
  }

  let callerPath = initiator.split('(')
  if (callerPath.length >= 2) {
    callerPath = callerPath[1].replace(')', '')
    callerPath = path.relative(cwd, callerPath)
  } else {
    callerPath = initiator
  }

  // const callerLine = _.find(lines, (line) => {
  //   const nodeModule = line.indexOf('node_modules') > -1
  //   const hasColon = line.indexOf(':') > -1
  //   const filenameJs = line.indexOf('logger/filename.js') > -1 || line.indexOf('logger\\filename.js') > -1
  //   const loggerJs = line.indexOf('logger/index.js') > -1 || line.indexOf('logger\\index.js') > -1
  //   const windowsJs = line.indexOf('logger/windows.js') > -1 || line.indexOf('logger\\windows.js') > -1
  //   const producerClass = line.indexOf('ProducerClass') > -1
  //   return !nodeModule && hasColon && !filenameJs && !loggerJs && !producerClass && !windowsJs
  // })
  //
  // if (!callerLine) {
  //   return ''
  // }
  // let callerParts = callerLine.split(':')
  // if (!callerParts || callerParts.length < 3) {
  //   return ''
  // }
  //
  // const callerFileParts = callerParts[0].split('(')
  // if (!callerFileParts || callerFileParts.length < 2) {
  //   return ''
  // }
  // const file = callerFileParts[1]
  // const lineNumber = _.trimEnd(callerParts[1], ')')
  //
  // return path.relative(process.cwd(), file) + ':' + lineNumber
  return callerPath
}
